/* Copyright 2019 Ling Zhang

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License. */

Object.defineProperty(exports,"__esModule",{value:!0});var e=require("@agentframework/domain");require("@agentframework/app"),require("@agentframework/data"),require("@agentframework/web");var t=require("stream"),r=require("path"),s=require("fs"),i=require("net"),o=require("protobufjs");function n(e,t,r,s){var i,o=arguments.length,n=o<3?t:null===s?s=Object.getOwnPropertyDescriptor(t,r):s;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)n=Reflect.decorate(e,t,r,s);else for(var a=e.length-1;a>=0;a--)(i=e[a])&&(n=(o<3?i(n):o>3?i(t,r,n):i(t,r))||n);return o>3&&n&&Object.defineProperty(t,r,n),n}function a(e,t){if("object"==typeof Reflect&&"function"==typeof Reflect.metadata)return Reflect.metadata(e,t)}let d;require("url");const p=new RegExp(/^text\/html/);function c(t,i,o={}){const n=r.normalize(r.resolve(o.root||t.settings.PUBLIC_DIR)),a="/"===(i=i||"/")[i.length-1];i=i.substr(r.parse(i).root.length);const c=o.index||"index.html",l=o.maxAge||t.settings.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS;i=function(t){try{return decodeURIComponent(t)}catch(t){throw new e.Exception(t,"failed to decode")}}(i),a&&(i+=c);const g=function(t,s){if(-1!==s.indexOf("\0"))throw new e.MaliciousRequestError("NULL is not allowed in request path");if(d||(d=/(?:^|[\\\/])\.\.(?:[\\\/]|$)/),d.test(r.normalize("."+r.sep+s)))throw new e.MaliciousRequestError("Up path (../) is not allowed in request path");if(r.isAbsolute(s))throw new e.MaliciousRequestError("Absolute path is not allowed");return r.normalize(r.join(r.resolve(t),s))}(n,i);if(function(e,t){const s=t.substr(e.length).split(r.sep);if(".well-known"===s[0])return!1;for(let e=0;e<s.length;e++)if("."===s[e][0])return!0;return!1}(n,g))return!1;let y;try{if((y=s.statSync(g)).isDirectory())return!1}catch(t){if(~["ENOENT","ENAMETOOLONG","ENOTDIR"].indexOf(t.code))return!1;throw new e.ApplicationError(t,"Unable to access requested file")}t.logger.update({sz:(y.size/1024).toFixed(1)});const u=t.res;var h,f;return u.lastModified||(u.lastModified=y.mtime),u.status=200,u.length=y.size,u.type=(h=g,"."===(f=""!==(f="")?r.extname(r.basename(h,f)):r.extname(h))[0]?f.slice(1):f),u.hasHeader("x-content-type-options")||u.setHeader("x-content-type-options","nosniff"),l>0?u.hasHeader("cache-control")||u.setHeader("cache-control","public, max-age="+l):(u.hasHeader("pragma")||u.setHeader("pragma","no-cache"),u.hasHeader("cache-control")||u.setHeader("cache-control","no-cache, no-store, must-revalidate")),u.type.match(p)&&(t.settings.DEBUG||u.setHeader("strict-transport-security","max-age=31536000; includeSubDomains"),Array.isArray(t.settings.WEB_CONTENT_SECURITY_POLICY)&&u.setHeader("content-security-policy",t.settings.WEB_CONTENT_SECURITY_POLICY.join(" ")),u.setHeader("x-frame-options","SAMEORIGIN"),u.setHeader("x-xss-protection","1")),u.body=s.createReadStream(g),t.state.silent=!0,{file:g,type:u.type,length:y.size}}class l{static get(e){const t=e.cookies.getAll(e.settings.WEB_DEVICE_COOKIE_KEY);if(t)return t[t.length-1]}static set(e,t){const r=e.settings.WEB_DEVICE_COOKIE_DOMAIN||e.hostname,s=e.settings.WEB_DEVICE_COOKIE_KEY,o={path:"/",httpOnly:!0,maxAge:e.settings.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS,secure:!e.settings.DEBUG};if(i.isIP(r))e.res.cookies.add(s,t,Object.assign({domain:r},o));else{const i=r.split(".");1===i.length&&e.res.cookies.add(s,t,Object.assign({domain:r},o)),i.length>1&&e.res.cookies.add(s,t,Object.assign({domain:i.slice(-2).join(".")},o)),i.length>2&&e.res.cookies.add(s,t,Object.assign({domain:i.slice(-3).join(".")},o))}return t}}class g{static getIdentityId(e){return this.verify(l.get(e))}static createIdentityId(t){const r=this.sign(e.Base62.fromBuffer((new e.ObjectId).id));return t.state.new_device_id=r,t.logger.update({new_device:1}),l.set(t,r)}static createIdentityAddress(e){const t=e.ip;let r=((t&&t.indexOf(":"))>=0?"/ip6/":"/ip4/")+t;const s=e.getHeader("x-forwarded-port");return s&&(r+="/tcp/"+s),r}static crc(t){let r=0;for(let e=0;e<t.length;e++)r+=t.charCodeAt(e);return e.Base62.singleton.alphabet[r%62]}static sign(e){return this.crc(e)+e}static verify(e){if(!e)return e;const t=e.slice(1),r=this.crc(t);return e[0]===r?t:void 0}}class y{static sign(t,r){const s=new e.Secret(t.settings.SECRET_KEYS,"sha512").sign(r);return e.Base62.fromBuffer(r)+"."+e.Base62.fromBuffer(s)}static verify(t,r){const s=r.indexOf(".");if(s>0&&s<r.length){const s=new e.Secret(t.settings.SECRET_KEYS,"sha512");try{const t=r.split("."),i=e.Base62.toBuffer(t[0]),o=e.Base62.toBuffer(t[1]);return!!s.verify(i,o)&&i}catch(e){return!1}}return!1}}class u{static get(e){const t=e.cookies.get(e.settings.WEB_SESSION_COOKIE_KEY);if(t&&t.length>40){const r=y.verify(e,t);if(r)return r;e.logger.warn({id:e.ip,cookie:t},"[INTRUSION DETECTED] User sent invalidate auth token:")}return null}static set(e,t){const r={path:"/api",httpOnly:!0,secure:!e.settings.DEBUG};e.res.cookies.add(e.settings.WEB_SESSION_COOKIE_KEY,y.sign(e,t),r)}static clear(e){const t={path:"/api",httpOnly:!0,maxAge:1,expires:new Date(2013,1,1),secure:!e.settings.DEBUG};e.res.cookies.set(e.settings.WEB_SESSION_COOKIE_KEY,"",t)}}class h{static get schema(){const e=o.Root.fromJSON({nested:{IdentityProfile:{fields:{_id:{type:"bytes",id:1},id:{type:"string",id:2},displayName:{type:"string",id:3},displayImageURL:{type:"string",id:4}}},WebSession:{fields:{session:{type:"string",id:1},user:{type:"string",id:2},token:{type:"string",id:3},roles:{type:"string",rule:"repeated",id:4},groups:{type:"string",rule:"repeated",id:5},scope:{type:"string",rule:"repeated",id:6},profile:{type:"IdentityProfile",id:7},timezone:{type:"string",id:8},locale:{type:"string",id:9},theme:{type:"string",id:10}}}}}).lookupType("WebSession");return Reflect.defineProperty(this,"schema",{value:e}),e}static encode(e){return this.schema.encode(e).finish()}static decode(e,t={}){let r;try{r=this.schema.decode(e)}catch(e){return null}for(const e of this.SessionFields)t[e]=r[e];if(r.profile){const e=t.profile||{};Object.assign(e,{_id:r.profile._id,id:r.profile.id,displayName:r.profile.displayName,displayImageURL:r.profile.displayImageURL}),t.profile=e}return t}}h.SessionFields=["session","user","token","roles","groups","scope","profile","theme","timezone","locale"];class f{static load(e,t){const r=u.get(e);r&&r.length&&h.decode(r,t)}static save(t,r){if(!r||!Object.keys(r).length)throw new e.ParameterError("Unable to update empty identity, please use WebIdentityService.clear() instead");const s=h.encode(r);if(!s||!s.byteLength)throw new e.AuthenticationError("Invalid session data (byteLength=0)");u.set(t,s)}static clear(e){for(const t of Object.keys(e.identity))"id"!==t&&"address"!==t&&delete e.identity[t];u.clear(e)}}class m extends e.WebRequestIdentity{static[e.ClassInitializer](t,r){const s=new m;if(s.id=g.getIdentityId(t)||g.createIdentityId(t),s.address=g.createIdentityAddress(t),t.path.startsWith("/api")){const r={};if(f.load(t,r),r&&r.session){new e.ObjectId(r.session).getTimestamp()>new Date&&Object.assign(s,r)}}return s.theme=s.theme||t.settings.THEME,s.locale=s.locale||t.settings.LOCALE,s.timezone=s.timezone||t.settings.TIMEZONE,s}}class E extends e.WebApplicationIdentity{static[e.ClassInitializer](e){const t=new E;return console.log("create app identity",e),t}}class _ extends e.WebApplication{addMiddleware(e){this.middleware.push(e)}invoke(e){return this.middleware.compose(e)}onInit(){const r=this;this.addType(m),this.addType(E),this.addMiddleware(function(t,r){return r().then(async r=>{null!=r&&t.logger.warn({result:r},"Return value from middleware is been ignored"),t.req.performance.log("router","[[End]]");let s,{total:i,header:o}=t.req.performance.build(t.settings.NAME);t.res.headers.set("x-response-time",i.toFixed(4)),t.res.headers.append("server-timing",o),s=i>1e3?0:i>100?1:i>10?2:3;const n={t:i.toFixed(s)};let a=`[${t.ip}] ${t.status} ${t.method} ${t.path}`;const d=t.logger,p=i>t.settings.LOG_SLOW_REQUEST_IN_MILLISECONDS;if(t.verbose||p){n.headers=function(e){const t=e.toJSON(),r={};for(const[e,s]of Object.entries(t))s.length&&(r[e]=s.length>1?s:s[0]);return r}(t.req.headers);try{n.identity=t.identity}catch(e){n.identity={__xXx__:e.message}}if(Object.keys(t.params).length&&(n.params=t.params),Object.keys(t.query).length&&(n.query=t.query),"POST"===t.method||"PUT"===t.method)try{n.body=await t.req.json()}catch(e){n.body={__xXx__:e.message}}}p&&(n.slow=1);const c=t.error;c?(c instanceof e.Exception&&(c.code&&(n.code=c.code),c.context&&(n.context=c.context)),d.error(c,n,a)):t.state.silent?d.trace(n,a):d.info(n,a)})}),this.addMiddleware(function(r,s){return s().then(s=>{const i=r.res;void 0===i.body&&(s instanceof t.Readable||Buffer.isBuffer(s)?i.body=s:i.body=function(e){return Array.isArray(e)?{ok:1,results:e}:void 0!==e?{ok:1,result:e}:{ok:1}}(s)),void 0===i.status&&(i.status=200),e.MakeCookieHeaders(r)}).catch(t=>{r.error=t;const{statusCode:s,statusMessage:i,headers:o,body:n}=function(t,r){let s,i,o=500,n="Server Exception";return r instanceof Error?r instanceof e.Exception?(r instanceof e.HttpError&&(r.headers&&(s=r.headers),r.statusCode&&(o=r.statusCode),r.statusMessage&&(n=r.statusMessage)),i=Object.assign({},r.toJSON(),{ok:0})):i={ok:0,error:r.name,message:r.message,stack:r.stack}:i={ok:0},{statusCode:o,statusMessage:n,headers:s,body:i}}(0,t);o&&r.res.setHeaders(o),null!=n&&(r.res.body=n),r.res.statusCode=s,r.res.statusMessage=i})}),this.addMiddleware(function(e,t){const s=`REQ/${Date.now()}`;e.req.logger.update({req_id:s}),e.setHeader("x-request-id",s),e.setHeader("x-request-count",String(e.req.id)),e.performance.log("router","[[LookupRoute]]");const i=r.router.search(e.method,e.path);return i&&(e.req.params=i.params,i.handler&&"function"==typeof i.handler)?i.handler(e):t()}),this.onInitApplication(),this.settings.PUBLIC_DIR?(this.logger.warn(`Serving files from ${this.settings.PUBLIC_DIR}`),this.addMiddleware(function(e,t){if("GET"===e.method){e.performance.log("router","[[ServeStaticFile]]");try{c(e,e.path)||(e.status=404,e.body={ok:0,message:"File Not Found"})}catch(t){e.logger.error(t,"send file")}}else e.status=405,e.body={ok:0,message:"Method Not Allowed"};return t()})):this.addMiddleware(function(e,t){return"GET"===e.method?(e.status=404,e.body={ok:0,message:"Route Not Found"}):(e.status=405,e.body={ok:0,message:"Method Not Allowed"}),t()})}}n([e.transit(),a("design:type",e.Sequence)],_.prototype,"middleware",void 0);class v{}class S extends v{}class I extends v{}class O extends e.Resolvable{}let b=class extends e.Model{static toJSON(e){return{provider:e.provider,providerProtocol:e.providerProtocol,providerURL:e.providerURL,providerFingerprint:e.providerFingerprint,providerConfiguration:JSON.stringify(e.providerConfiguration),appID:e.appID,appSecret:e.appSecret,scope:e.scope,displayName:e.displayName,displayImageURL:e.displayImageURL,description:e.description,createdAt:e.createdAt,createdFrom:e.createdFrom,createdBy:e.createdBy?JSON.stringify(e.createdBy):"{}",expireAt:e.expireAt,updatedAt:e.updatedAt,updatedFrom:e.updatedFrom,updatedBy:e.updatedBy?JSON.stringify(e.updatedBy):"{}"}}fromJSON(e){this.provider=e.provider,this.providerProtocol=e.providerProtocol,this.providerURL=e.providerURL,this.providerFingerprint=e.providerFingerprint,this.providerConfiguration=e.providerConfiguration?JSON.parse(e.providerConfiguration):{},this.appID=e.appID,this.appSecret=e.appSecret,this.scope=e.scope,this.displayName=e.displayName,this.displayImageURL=e.displayImageURL,this.description=e.description,this.createdAt=e.createdAt,this.createdFrom=e.createdFrom,this.createdBy=e.createdBy?JSON.parse(e.createdBy):{},this.expireAt=e.expireAt,this.updatedAt=e.updatedAt,this.updatedFrom=e.updatedFrom,this.updatedBy=e.updatedBy?JSON.parse(e.updatedBy):{}}};n([e.property(),a("design:type",String)],b.prototype,"provider",void 0),n([e.property(),a("design:type",String)],b.prototype,"providerProtocol",void 0),n([e.property(),a("design:type",String)],b.prototype,"providerURL",void 0),n([e.property(),a("design:type",String)],b.prototype,"providerFingerprint",void 0),n([e.property(),a("design:type",Object)],b.prototype,"providerConfiguration",void 0),n([e.property(),a("design:type",String)],b.prototype,"appID",void 0),n([e.property(),a("design:type",String)],b.prototype,"appSecret",void 0),n([e.property(),a("design:type",String)],b.prototype,"scope",void 0),n([e.property(),a("design:type",String)],b.prototype,"displayName",void 0),n([e.property(),a("design:type",String)],b.prototype,"displayImageURL",void 0),n([e.property(),a("design:type",String)],b.prototype,"description",void 0),b=n([e.model("ExternalProvider")],b);class x extends e.RecordCollection{constructor(){super(b)}}let N=class extends e.Model{};n([e.property(),a("design:type",Object)],N.prototype,"uid",void 0),n([e.property(),a("design:type",String)],N.prototype,"provider",void 0),n([e.property(),a("design:type",String)],N.prototype,"providerProtocol",void 0),n([e.property(),a("design:type",String)],N.prototype,"providerURL",void 0),n([e.property(),a("design:type",String)],N.prototype,"providerId",void 0),n([e.property(),a("design:type",String)],N.prototype,"providerData",void 0),n([e.property(),a("design:type",String)],N.prototype,"userData",void 0),n([e.property(),a("design:type",String)],N.prototype,"user",void 0),n([e.property(),a("design:type",String)],N.prototype,"username",void 0),n([e.property(),a("design:type",String)],N.prototype,"domain",void 0),n([e.property(),a("design:type",Object)],N.prototype,"email",void 0),n([e.property(),a("design:type",Boolean)],N.prototype,"emailCertified",void 0),n([e.property(),a("design:type",Object)],N.prototype,"mobile",void 0),n([e.property(),a("design:type",Boolean)],N.prototype,"mobileCertified",void 0),n([e.property(),a("design:type",String)],N.prototype,"displayName",void 0),n([e.property(),a("design:type",String)],N.prototype,"displayImageURL",void 0),n([e.property(),a("design:type",String)],N.prototype,"displayImageFile",void 0),n([e.property(),a("design:type",Object)],N.prototype,"familyName",void 0),n([e.property(),a("design:type",Object)],N.prototype,"givenName",void 0),n([e.property(),a("design:type",Object)],N.prototype,"gender",void 0),n([e.property(),a("design:type",Object)],N.prototype,"dob",void 0),n([e.property(),a("design:type",Object)],N.prototype,"status",void 0),n([e.property(),a("design:type",Object)],N.prototype,"bio",void 0),n([e.property(),a("design:type",Object)],N.prototype,"homepage",void 0),n([e.property(),a("design:type",Object)],N.prototype,"locale",void 0),N=n([e.model("external_user")],N);class C extends e.RecordCollection{constructor(){super(N)}}class w extends e.Resolvable{}class R extends O{dispatch(e,t){console.log("dispatch",t)}}class B{static generateRandomNumber(e){const t=Math.pow(10,e-1),r=Math.pow(10,e);return Math.floor(Math.random()*(r-t)+t)}static generateRandomToken(e){const t=[],r=this.POOL,s=this.MAX;for(let i=0;i<e;i++){const e=Math.floor(Math.random()*s);t.push(r[e])}return t.join("")}}B.POOL="2346789BbCcDdFfGgHhJjKkMmPpQqRrTtVvWwXxYy",B.MAX=B.POOL.length;class A extends m{}class T extends A{static[e.ClassInitializer](t,[r]){let s=`${r.first_name}`;r.last_name&&(s+=` ${r.last_name}`);const i={uid:r.id,providerId:"3fdeba596a7d938a05c38daf"},o=e.CreateHashedObjectId(i).toHexString(),n=new T;return n.id=r.id,n.address=g.createIdentityAddress(t)+"/tg/"+r.id,n.user=o,n.profile={_id:o,id:r.username,displayName:s,displayImageURL:""},r.is_bot&&(n.profile.bot=r.is_bot),n.theme=n.theme||t.settings.THEME,n.locale=r.language_code||t.settings.LOCALE,n.timezone=n.timezone||t.settings.TIMEZONE,n}}exports.TelegramBotController=class extends w{async telegram(t){if(!t.params.token)throw new e.ParameterError("Missing bot token for telegram");if(t.settings.TELEGRAM_BOT_TOKEN!=t.params.token)throw new e.ParameterError("Invalid bot token");const r=await t.json(),s=r.channelData||r,i=await t.resolve(T,function(t){const r=t.message||t.callback_query||t.edited_message||t.pre_checkout_query;let s;if(r)s=r.from;else{const r=Object.keys(t),i=r.find(e=>!!t[e].from);if(!i)throw new e.ParameterError(`Unable to find 'from' field in message: ${r}`);s=t[i].from}return[s,r,t]}(s));let o,n,a,d;if(s.message)n=(o=s.message).chat,d=o.text,a=new Date(1e3*o.date);else if(s.callback_query)n=(o=s.callback_query.message).chat,d=s.callback_query.data,a=new Date(1e3*o.date);else{if(!s.pre_checkout_query)return s.edited_message?(this.logger.debug({sourceEvent:s},"Edit message is ignored in this version"),void(t.body=null)):(this.logger.error({sourceEvent:s},"Unknown message type"),void(t.body=null));{const e=s.pre_checkout_query.from;n={id:e.id,first_name:e.first_name,last_name:e.last_name,username:e.username,type:"private"},d=s.pre_checkout_query.invoice_payload,a=new Date}}const p={id:B.generateRandomToken(10),type:"message",identity:i,timestamp:a,from:{id:i.id,name:i.profile.displayName},conversation:{isGroup:"private"!==n.type,id:n.id},recipient:{id:t.settings.TELEGRAM_BOT_ID,name:t.settings.NAME},channelId:"telegram",channelData:s,text:d};this.bot.dispatch(t,p)}},n([e.singleton(),a("design:type",R)],exports.TelegramBotController.prototype,"bot",void 0),n([e.method("POST","/update/:token"),a("design:type",Function),a("design:paramtypes",[Object]),a("design:returntype",Promise)],exports.TelegramBotController.prototype,"telegram",null),exports.TelegramBotController=n([e.controller("/api/integration/telegram/bot")],exports.TelegramBotController),exports.WebFoundationApplication=_,exports.WebFoundationSettings=class extends e.WebApplicationSettings{constructor(){super(...arguments),this.PUBLIC_DIR_CACHE_EXPIRES_IN_SECONDS=600,this.LOG_SLOW_REQUEST_IN_MILLISECONDS=1e4,this.WEB_DEVICE_COOKIE_KEY="__xXx__",this.WEB_DEVICE_COOKIE_EXPIRES_IN_SECONDS=3456e4,this.WEB_SESSION_COOKIE_KEY="__xXx__",this.WEB_SESSION_COOKIE_EXPIRES_IN_SECONDS=1800,this.WEB_SESSION_EXPIRES_IN_MILLISECONDS=18e5,this.WEB_CONTENT_SECURITY_POLICY=["script-src","'self'"],this.TRUSTED_EMAIL_PROVIDERS=[],this.THEME="default",this.OWNER_COMPANY_ADDRESS=[],this.OWNER_AGREEMENTS=[],this.WEB_TOKEN_EXPIRES_IN_MILLISECONDS=3e4,this.WEB_SIGNIN_PATH="/authentication/signin",this.WEB_SIGNIN_SUCCESS_PATH="/authentication/validate",this.WEB_SIGNIN_FAILED_PATH="/authentication/failed",this.WEB_ACCESS_DENIED_PATH="/authentication/access_denied",this.WEB_SIGNOUT_PATH="/authentication/signout",this.WEB_SIGNOUT_COMPLETE_PATH="/"}},exports.FormField=v,exports.TextField=I,exports.FileField=S,exports.WebForm=class extends Array{prepare(){if(!this.texts||!this.files){this.texts=new Map,this.files=new Map;for(const e of this)if(e instanceof I){let t=this.texts.get(e.name);t||(t=[],this.texts.set(e.name,t)),t.push(e.value)}else if(e instanceof S){let t=this.files.get(e.name);t||(t=[],this.files.set(e.name,t)),t.push(e)}}}getText(e){this.prepare();let t=this.texts.get(e);return t&&t[0]}getFile(e){if(this.prepare(),"string"==typeof e){let t=this.files.get(e);return t&&t[0]}for(const e of this.files.values())return e[0]}getFiles(e){if(this.prepare(),"string"==typeof e)return this.files.get(e)||[];let t=[];for(const e of this.files.values())t=t.concat(...e);return t}},exports.ExternalProviderService=class extends O{async findOrCreateExternalProvider(t,r){console.log("2222");const s=e.CreateHashedObjectId({provider:r.provider,providerProtocol:r.providerProtocol,providerURL:r.providerURL}),i=await t.resolve(x),o=await i.get(s);return o||i.add(s,r).then(e=>{if(!e)throw new Error("Unable to create external provider");return e})}},exports.ExternalUserService=class extends O{async findOrCreateExternalUser(e,t,r){const s=await e.resolve(C),i=await s.get(t);return i||s.add(t,r).then(e=>{if(!e)throw new Error("Unable to create external user");return e})}},exports.BotService=R;
//# sourceMappingURL=index.js.map
